//
//  ParalellMA.h
//  
//
//  Created by Lucas Angelo on 01/02/16.
//
//

#ifndef _ParalellMA_h
#define _ParalellMA_h
#include "structure.h"
void read_permutation_of_archivo(char* name, permutation *perm);

void population_init(population *pob, permutation *perm, float porc_reemp, float porc_selection);

void countingSort(population *pob, int k);

void selection(population *pob,  int n_generetion, int * best_solution);

void crossover(population *pob, permutation *perm, float prob_crossover);

void mutation(population *pob, permutation *perm, float prob_mutation);

void replacement(population *pob);

int auxlocal_search2(population *pob, int i);

int * auxlocal_search(msgGenome input);

void local_search(population *pob, int nro_generation,float probability_ls, float porc_localsearch);

void restarting_population(population *pob, permutation *perm, float porc_retain);

int reset_population(population *pob, int i, float limiteentropia);

void see_population(permutation *perm,population *pob);

void see_fitness(population *pob ,int flag);

int calcular_fitness_mpi(msgGenome input);

void fitness_mpi(population *pob, int base, int tope);
void gerar_sementes(int tamanhoc,population *pob, int * sementes);
void slave(void);
void master(void);


#endif
