//
//  MPMPE.h
//  
//
//  Created by Lucas Angelo on 03/02/16.
//
//

#ifndef _MAMPNE_h
#define _MAMPNE_h
#include "structure.h"
#include <mpi.h>
void read_permutation_of_archivo(char* name, permutation *perm);
void population_init(population *pob, permutation *perm);
void fitness_population(population *pob, int flag);
void countingSort(population *pob, int k);
void selection(population *pob,  int n_generetion, int * best_solution);
void crossover(population *pob, permutation *perm);
void mutation(population *pob, permutation *perm);
void replacement(population *pob);
int auxlocal_search(population *pob, int i);
void local_search(population *pob, int nro_generation);
void restarting_population(population *pob, permutation *perm);
int reset_population(population *pob, int i);
void see_population(permutation *perm,population *pob);
void see_fitness(population *pob ,int flag);
int * allocate_space();
void my_bcast( int geration, MPI_Comm communicator, int world_rank, int flag, population *pob,float prob_insertion);

void MemetiAlg(MPI_Comm communicator, int world_rank, float parameter);

#endif
